// MBView.cpp : implementation of the CMBView class
//

#include "stdafx.h"
#include "Moebius.h"

#include "MBDoc.h"
#include "MBView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMBView

IMPLEMENT_DYNCREATE(CMBView, CFormView)

BEGIN_MESSAGE_MAP(CMBView, CFormView)
ON_BN_CLICKED(IDC_BUTTON_APPLY, OnBnClickedButtonApply)
ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RADIUS, OnDeltaposSpinRadius)
ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_FILLET, OnDeltaposSpinFillet)
ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_SIDE_NUM, OnDeltaposSpinSideNum)
ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_RADIUS_SEC, OnDeltaposSpinRadiusSec)
ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_TURN, OnDeltaposSpinTurn)
ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_STEPS, OnDeltaposSpinSteps)
END_MESSAGE_MAP()

// CMBView construction/destruction

CMBView::CMBView()
	: CFormView(CMBView::IDD)
{
	// TODO: add construction code here

}

CMBView::~CMBView()
{
}

void CMBView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_ctrlWidth);
	DDX_Control(pDX, IDC_EDIT_RADIUS, m_ctrlRadius);
	DDX_Control(pDX, IDC_EDIT_FILLET, m_ctrlFillet);
	DDX_Control(pDX, IDC_EDIT_SIDE_NUM, m_ctrlSideNum);
	DDX_Control(pDX, IDC_EDIT_TURN, m_ctrlTurn);
	DDX_Control(pDX, IDC_EDIT_STEPS, m_ctrlSteps);
}

BOOL CMBView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CMBView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	
	//ResizeParentToFit(false);
}


// CMBView diagnostics

#ifdef _DEBUG
void CMBView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMBView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMBDoc* CMBView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMBDoc)));
	return (CMBDoc*)m_pDocument;
}
#endif //_DEBUG


// CMBView message handlers



void CMBView::OnBnClickedButtonApply()
{
	CString buf;
	CMBDoc *pd=GetDocument();
	m_ctrlRadius.GetWindowText(buf);
	pd->m.Radius=(float)atof(buf);

	m_ctrlWidth.GetWindowText(buf);
	pd->m.InnerRadius=(float)atof(buf);

	m_ctrlFillet.GetWindowText(buf);
	pd->m.FilletRatio=(float)atof(buf);

	pd->m.Clear();
	pd->UpdateAllViews(0);
}

void CMBView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
	CString buf;
	buf.Format("%i",GetDocument()->m.StepNum);
	m_ctrlSteps.SetWindowText(buf);
	buf.Format("%4.1f",GetDocument()->m.Turns);
	m_ctrlTurn.SetWindowText(buf);
	buf.Format("%i",GetDocument()->m.SideNum);
	m_ctrlSideNum.SetWindowText(buf);
	buf.Format("%4.2f",GetDocument()->m.InnerRadius);
	m_ctrlWidth.SetWindowText(buf);
	buf.Format("%4.2f",GetDocument()->m.FilletRatio);
	m_ctrlFillet.SetWindowText(buf);
	buf.Format("%4.2f",GetDocument()->m.Radius);
	m_ctrlRadius.SetWindowText(buf);
}

void CMBView::OnDeltaposSpinRadius(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CMBDoc *pd=GetDocument();
	if(pNMUpDown->iDelta<0) pd->m.Radius+=.5;
	if(pNMUpDown->iDelta>0) pd->m.Radius-=.5;
	pd->m.Clear();
	pd->UpdateAllViews(0);
  *pResult = 0;
}

void CMBView::OnDeltaposSpinFillet(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CMBDoc *pd=GetDocument();
	if(pNMUpDown->iDelta<0) pd->m.FilletRatio+=.05f;
	if(pNMUpDown->iDelta>0) pd->m.FilletRatio-=.05f;
	pd->m.Clear();
	pd->UpdateAllViews(0);
  *pResult = 0;
}

void CMBView::OnDeltaposSpinSideNum(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CMBDoc *pd=GetDocument();
	if(pNMUpDown->iDelta<0) pd->m.SideNum+=1;
	if(pNMUpDown->iDelta>0) { pd->m.SideNum-=1; if(pd->m.SideNum<2) pd->m.SideNum=2;}
	pd->m.Clear();
	pd->UpdateAllViews(0);
  *pResult = 0;
}

void CMBView::OnDeltaposSpinRadiusSec(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CMBDoc *pd=GetDocument();
	if(pNMUpDown->iDelta<0) pd->m.InnerRadius+=.5f;
	if(pNMUpDown->iDelta>0) pd->m.InnerRadius-=.5f;
	pd->m.Clear();
	pd->UpdateAllViews(0);
	*pResult = 0;
}

void CMBView::OnDeltaposSpinTurn(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CMBDoc *pd=GetDocument();
	if(pNMUpDown->iDelta<0) pd->m.Turns+=1;
	if(pNMUpDown->iDelta>0) { pd->m.Turns-=1; if(pd->m.Turns<0) pd->m.Turns=0;}
	pd->m.Clear();
	pd->UpdateAllViews(0);
	*pResult = 0;
}

void CMBView::OnDeltaposSpinSteps(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CMBDoc *pd=GetDocument();
	if(pNMUpDown->iDelta<0) pd->m.StepNum+=10;
	if(pNMUpDown->iDelta>0) { pd->m.StepNum-=10; if(pd->m.StepNum<0) pd->m.StepNum+=10;}
	pd->m.Clear();
	pd->UpdateAllViews(0);
	*pResult = 0;
}
