#pragma once
#include<vector>
#include<GL/gl.h>
#include<GL/glu.h>
#include<math.h>

#include<vcg/Point3.h>

using namespace std;
using namespace vcg;

class CIVertex
{
public :
	CIVertex(Point3f &pp, Point3f &nn) {p=pp; n=nn;}
	CIVertex(Point3f &pp, Point3f &nn,float ss, float tt) {p=pp; n=nn; s=ss; t=tt;}
	Point3f p;
	Point3f n;
	float s,t;
};

class CIFace
{
public:
	CIVertex *v[3];
	Point3f n;
};

class CIMesh {
public:
	vector< CIVertex > vert;
	vector< CIFace > face;
	void ComputeFaceNormal();
	void ComputeVertNormal();

	template <bool NormFlag, bool TexFlag> Draw()
	{
		glBegin(GL_TRIANGLES);
		vector<CIFace>::const_iterator fi;
		for(fi=face.begin();fi!=face.end();++fi)
		{
			if(NormFlag) glNormal((*fi).v[0]->n);
			if(TexFlag) glTexCoord2f((*fi).v[0]->s,(*fi).v[0]->t);
			glVertex((*fi).v[0]->p);
			if(NormFlag) glNormal((*fi).v[1]->n);
			if(TexFlag) glTexCoord2f((*fi).v[1]->s,(*fi).v[1]->t);
			glVertex((*fi).v[1]->p);
			if(NormFlag) glNormal((*fi).v[2]->n);
			if(TexFlag)  glTexCoord2f((*fi).v[2]->s,(*fi).v[2]->t);
			glVertex((*fi).v[2]->p);
		}
		glEnd();
	}
	
	void DrawPoints();
	bool Empty() const {return vert.empty() &&  face.empty();}
	void Clear();
};
